// Lscht den Fader
////////////////////////////////////////////////////////////////////
void clear_fader(void)

{ 
  fader_timer_main = 0;
  fader_timer_old = 0;
  fader_timer_new = 0;
}

// bergt ein Zeichen in den Fader
////////////////////////////////////////////////////////////////////
void set_fader_digit(u08 no, u08 digit)

{
  fader_digits_new[no] = digit;
  fader_digits_old[no] = display_digits[no];
}

// Startet das Fading
////////////////////////////////////////////////////////////////////
void start_fader(void)

{
  fader_timer_old = eeprom_data.fading_time;
  fader_timer_main = eeprom_data.fading_time;
}

// Liefert in Abhngigkeit der Fader-Counter
// das nchste Zeichen zur Anzeige
////////////////////////////////////////////////////////////////////
u08 next_fader_digit(u08 no)

{
  // Wenn der Zhler abgelaufen ist liefere aktuelles 
  // Zeichen zurck d. h. keine nderung der Anzeige
  if (!fader_timer_main)
    return display_digits[no];

  if (fader_timer_old)
  {
    if (no == 5)
      fader_timer_old--;
    return fader_digits_old[no];
  }
 
  if (no == 5)
  {
    if (fader_timer_new)
      fader_timer_new--;
    if (!fader_timer_new)
    {
      fader_timer_main--;
      fader_timer_old = fader_timer_main;
      fader_timer_new = eeprom_data.fading_time-fader_timer_old;
    }
  }
  return fader_digits_new[no];
} 


void clear_tubes(void)

{
  u08 temp;

  outp(0,TUBE_VAL07_PORT);	// lschen der digits 0-7
  
  temp = inp(TUBE_VAL89_PORT);  // lschen der digits 8-9
  temp &= ~TUBE_VAL89_MASK;
  outp(temp,TUBE_VAL89_PORT);
  
  temp = inp(TUBE_SEL_PORT);	// lschen der selektion
  temp &= ~TUBE_SEL_MASK;
  outp(temp,TUBE_SEL_PORT);

}


// Dies ist die Funktion zum Update der Rhren
// Sie wird als Interrupt-Routine von Timer 0 aufgerufen
// und steuert das Multiplexing
////////////////////////////////////////////////////////////////////
SIGNAL(SIG_OVERFLOW0)        
{
  static u08 tube_no = 0;
  static u08 tube_mask;
  static u08 h1 = 0;
//  static u08 x = 0;
  
  u08 temp, temp2;
  
   sei();    			// Interupts ermglichen damit die zeit richtig luft?
  
//  if (x == 1)
//    button_tone_on;
//  x = 1;


  clear_tubes();
 
  tube_no++;			// erhhen des rhren-selektors 
  if (tube_no > 5)
    tube_no = 0;
    
  if (tube_no == 0)
  { 

    h1++;			// Zhler fr den Dunkelwert beim Blinken
    if (h1 > 4) h1 = 0;  
  }
  
  tube_mask = 4 << tube_no;		// bit fr die selektion der nchsten rhre
  
  display_digits[tube_no] = next_fader_digit(tube_no);
  
  if ((tube_mask & display_mask) || !h1)
    temp = display_digits[tube_no];
  else
    temp = no_digit;
  
  if (T1CV < 255)
  { 
    if (temp <= 9)
    {
      outp(tube_mask,TUBE_SEL_PORT);	// selektion wenn gltige Ziffer 
      
      if (temp <= 7)
      {
        temp2 = 1 << temp;
        outp(temp2,TUBE_VAL07_PORT);
      }
      else 
      {
        if (temp <= 9)
        {
          if (temp == 8)
            temp2 = 0x20;
          else
            temp2 = 0x10;
          temp = inp(TUBE_VAL89_PORT);
          temp |= temp2;
          outp(temp,TUBE_VAL89_PORT);
        }
      }
    }
  
   
  }

  temp = inp(LAMPS_PORT);
  temp &= NOT_LAMPS;
  temp |= lamp_stat;
  outp(temp,LAMPS_PORT);
  
  if (T1CV != T0CV)
  {
    outp(0xFF,TCNT1H);
    outp(T1CV,TCNT1L);
    outp(T0PSC,TCCR1B); 
  }

  outp(T0CV,TCNT0);
//  x = 0;
}


SIGNAL(SIG_OVERFLOW1)        
{
  u08 temp;
  
  clear_tubes();

  temp = inp(LAMPS_PORT);
  temp &= NOT_LAMPS;
  outp(temp,LAMPS_PORT);

  outp(0,TCCR1B); 
}
