void char_to_uart_obuf(u08 c)

{ 
  if (uart_obuf_len < UART_OBUF_SIZE)
  {
    uart_obuf_last++;
    if (uart_obuf_last == UART_OBUF_SIZE)
      uart_obuf_last = 0;
    uart_obuf[uart_obuf_last] = c;
    uart_obuf_len++;
  }
}


void check_uart_obuffer(void)

{ u08 temp;

  if (uart_obuf_len == 0) // Nix zum senden
    return;

  temp = inp(USR);
  if (temp & 0x20) // UART Data Register Empty
  {
    outp(uart_obuf[uart_obuf_first],UDR);
    uart_obuf_first++;
    if (uart_obuf_first == UART_OBUF_SIZE)
      uart_obuf_first = 0;
    uart_obuf_len--;
  }
}

void CrLf2UART(void)

{
  char_to_uart_obuf(0x0d);
  char_to_uart_obuf(0x0a);
}


/*
void char_to_uart_ibuf(u08 c)

{ 
  if (uart_ibuf_len < UART_IBUF_SIZE)
  {
    uart_ibuf_last++;
    if (uart_ibuf_last == UART_IBUF_SIZE)
      uart_ibuf_last = 0;
    uart_ibuf[uart_ibuf_last] = c;
    uart_ibuf_len++;
  }
}


char char_from_uart_ibuf(void)

{ u08 temp;
  
  temp = 0xFF;
  if (uart_ibuf_len)
  {
    temp = uart_ibuf[uart_ibuf_first]; 
    uart_ibuf_first++;
    if (uart_ibuf_first == UART_IBUF_SIZE)
      uart_ibuf_first = 0;
    uart_ibuf_len--;
  }
  return temp;
}
*/

void long2UART(unsigned long l)

{ unsigned long ltemp;
  u08 i,chars[6];
  
  ltemp = l;
  for (i = 0; i < 6; i++)
  {
    chars[i] = ltemp % 10 + '0';
    ltemp = ltemp / 10;
  }
  for (i = 0; i < 6; i++)
    char_to_uart_obuf(chars[5-i]);
}

void byte2UART3(u08 b)

{
  char_to_uart_obuf(b / 100 + '0');
  char_to_uart_obuf(b % 100 / 10 + '0');
  char_to_uart_obuf(b % 10 + '0');
  CrLf2UART();
}

void byte2UART2(u08 b)

{
  char_to_uart_obuf(b / 10 + '0');
  char_to_uart_obuf(b % 10 + '0');
}

u08 value_buf2byte(u08 pos, u08 len)

{ u08 temp,i,j;
  
  temp = 0;
  j = pos+len;
  if (j > value_len) 
    j = value_len;
  for (i=pos; i<j; i++)
    if ((value_buf[i] >= '0') && (value_buf[i] <= '9'))
      temp = temp * 10 +(value_buf[i]-'0');
    else
      return 0;
  return temp;
}

void value_buf2time(time_rec *t1)

{
  (*t1).hour = value_buf2byte(0,2);
  (*t1).min  = value_buf2byte(3,2);
  (*t1).sec  = value_buf2byte(6,2);
}


char high_char(u08 value)

{
  return value / 10 + '0';
}


char low_char(u08 value)

{
  return value % 10 + '0';
}

void time_value2UART(time_rec a_time)

{ 
  byte2UART2(a_time.hour);

  char_to_uart_obuf(':');

  byte2UART2(a_time.min);

  char_to_uart_obuf(':');

  byte2UART2(a_time.sec);

}


void time2UART(void)

{ u08 temp;

  time_value2UART(the_time);

  char_to_uart_obuf(' ');
  char_to_uart_obuf(low_char(dcf_sync_state));
  char_to_uart_obuf(low_char(dcf_receiving_state));
  temp = inp(SWITCH_PORT) & SWITCH_PIN_MASK;
  if (buzzer_counter)
    temp += 1;
  
  char_to_uart_obuf(low_char(temp));
    
  CrLf2UART();
}


void date2UART(void)

{ 
  byte2UART2(day);
  char_to_uart_obuf('.');
  byte2UART2(mon);
  char_to_uart_obuf('.');
  byte2UART2(year);

  CrLf2UART();
}


void pbuf2pnum(void)

{
  pnum = (pnum_buf[0]-'0') * 10 + (pnum_buf[1]-'0');
  if ((!pnum) || (pnum > MAX_PNUM))
    pnum = 0xFF;
}

void pnum_to_uart(void)

{
  char_to_uart_obuf('P');
  char_to_uart_obuf(pnum_buf[0]);
  char_to_uart_obuf(pnum_buf[1]);
  char_to_uart_obuf('=');
}

// Einzelne if-abfragen bentigen weniger platz als switch-anweisung
// kann mit ATMEGA gendert werden

void send_param_to_uart(void)

{
  pnum_to_uart();
  
  if (pnum == PNUM_COUNTER1)
  {
    long2UART(get_opcounter_value(OPCOUNTER_TOTAL));
    CrLf2UART();
    return;
  }
  
  if (pnum == PNUM_COUNTER2)
  {
    long2UART(get_opcounter_value(OPCOUNTER_TRIP));
    CrLf2UART();
    return;
  }
  
  if (pnum == PNUM_DAYTIME)
  {
    time_value2UART(the_time);
    CrLf2UART();
    return;
  }
  
  if (pnum == PNUM_DATE)
  {
    date2UART();
    return;
  }
  
  if (pnum == PNUM_FALLBACK)
  {
    byte2UART3(eeprom_data.fallback_ticks);
    CrLf2UART();
    return;
  }
  
  if (pnum == PNUM_SYNC_MIN)
  {
    byte2UART3(eeprom_data.sync_minutes);
    CrLf2UART();
    return;
  }
  
  if (pnum == PNUM_ALARM_TIME)
  {
    time_value2UART(eeprom_data.alarm_time);
    CrLf2UART();
    return;
  }
  
  if (pnum == PNUM_ALARM_SECS)
  {
    byte2UART3(eeprom_data.al_duration);
    CrLf2UART();
    return;
  }
  
  if (pnum == PNUM_SW_ON)
  {
    time_value2UART(eeprom_data.sw_on_time);
    CrLf2UART();
    return;
  }
  if (pnum == PNUM_SW_OFF)
  {
    time_value2UART(eeprom_data.sw_off_time);
    CrLf2UART();
    return;
  }
  
  if (pnum == PNUM_DCF_SPECIAL)
  {
    byte2UART3(dcf_special_bits);
    CrLf2UART();
    return;
  }

  if (pnum == PNUM_VERSION)
  {
    char_to_uart_obuf(version_hi);
    char_to_uart_obuf('.');
    char_to_uart_obuf(version_lo);
    char_to_uart_obuf(version_rev);
    CrLf2UART();
    return;
  }

  if (pnum == PNUM_DARK_START1)
  {
    byte2UART3(eeprom_data.dark_start1);
    CrLf2UART();
    return;
  }
 
  if (pnum == PNUM_DARK_END1)
  {
    byte2UART3(eeprom_data.dark_end1);
    CrLf2UART();
    return;
  }
 
  if (pnum == PNUM_DARK_START2)
  {
    byte2UART3(eeprom_data.dark_start2);
    CrLf2UART();
    return;
  }
  
  if (pnum == PNUM_DARK_END2)
  {
    byte2UART3(eeprom_data.dark_end2);
    CrLf2UART();
    return;
  }

  if (pnum == PNUM_DARK_VALUE1)
  {
    byte2UART3(eeprom_data.dark_value1);
    CrLf2UART();
    return;
  }

  if (pnum == PNUM_DARK_VALUE2)
  {
    byte2UART3(eeprom_data.dark_value2);
    CrLf2UART();
    return;
  }

  if (pnum == PNUM_DCF_OFFSET)
  {
    byte2UART3(eeprom_data.dcf_offset+24);
    CrLf2UART();
    return;
  }

  if (pnum == PNUM_FADING_TIME)
  {
    byte2UART3(eeprom_data.fading_time);
    CrLf2UART();
    return;
  }
}


// Einzelne if-abfragen bentigen weniger platz als switch-anweisung
// kann mit ATMEGA gendert werden

void set_value_from_uart(void)

{ u08 temp;

  if (pnum == PNUM_COUNTER2)
  {
    reset_opcounter(OPCOUNTER_TRIP);
    send_param_to_uart();
    return;
  }

  if (pnum == PNUM_DAYTIME)
  {
    value_buf2time(&the_time);
    if (dcf_sync_state != ss_no_sync_needed)
      dcf_sync_state = ss_manual;
    send_param_to_uart();
    return;
  }
  
  if (pnum == PNUM_DATE)
  {
    day = value_buf2byte(0,2);
    mon = value_buf2byte(3,2);
    year = value_buf2byte(6,2);
    add_day();
    subtract_day();
    if (dcf_sync_state != ss_no_sync_needed)
      dcf_sync_state = ss_manual;
    send_param_to_uart();
    return;
  }
  
  if (pnum == PNUM_FALLBACK)
  {
    eeprom_data_wbv(&eeprom_data.fallback_ticks,value_buf2byte(0,3));
    send_param_to_uart();
    return;
  }
  
  if (pnum == PNUM_SYNC_MIN)
  {
    temp = eeprom_data.sync_minutes;
    eeprom_data_wbv(&eeprom_data.sync_minutes,value_buf2byte(0,3));
    if (!eeprom_data.sync_minutes)
      dcf_sync_state = ss_no_sync_needed;
    else
      if (!temp)
        invalidate_dcf_time();
    send_param_to_uart();
    return;
  }
  
  if (pnum == PNUM_ALARM_TIME)
  {
    value_buf2time(&eeprom_data.alarm_time);
    eeprom_data_wt(&eeprom_data.alarm_time);
    send_param_to_uart();
    return;
  }
  
  if (pnum == PNUM_ALARM_SECS)
  {
    eeprom_data_wbv(&eeprom_data.al_duration,value_buf2byte(0,3));
    send_param_to_uart();
    return;
  }
  
  if (pnum == PNUM_SW_ON)
  {
    value_buf2time(&eeprom_data.sw_on_time);
    eeprom_data_wt(&eeprom_data.sw_on_time);
    send_param_to_uart();
    return;
  }
  if (pnum == PNUM_SW_OFF)
  {
    value_buf2time(&eeprom_data.sw_off_time);
    eeprom_data_wt(&eeprom_data.sw_off_time);
    send_param_to_uart();
    return;
  }
  
  if (pnum == PNUM_DARK_START1)
  {
    temp = value_buf2byte(0,3);
    if (temp < 24)
      eeprom_data_wbv(&eeprom_data.dark_start1,temp);
    send_param_to_uart();
    return;
  }
 
  if (pnum == PNUM_DARK_END1)
  {
    temp = value_buf2byte(0,3);
    if (temp < 24)
      eeprom_data_wbv(&eeprom_data.dark_end1,temp);
    send_param_to_uart();
    return;
  }
 
  if (pnum == PNUM_DARK_START2)
  {
    temp = value_buf2byte(0,3);
    if (temp < 24)
      eeprom_data_wbv(&eeprom_data.dark_start2,temp);
    send_param_to_uart();
    return;
  }
  
  if (pnum == PNUM_DARK_END2)
  {
    temp = value_buf2byte(0,3);
    if (temp < 24)
      eeprom_data_wbv(&eeprom_data.dark_end2,temp);
    send_param_to_uart();
    return;
  }

  if (pnum == PNUM_DARK_VALUE1)
  {
    temp = value_buf2byte(0,3);
    if (temp <= 10)
      eeprom_data_wbv(&eeprom_data.dark_value1,temp);
    send_param_to_uart();
    return;
  }

  if (pnum == PNUM_DARK_VALUE2)
  {
    temp = value_buf2byte(0,3);
    if (temp <= 10)
      eeprom_data_wbv(&eeprom_data.dark_value2,temp);
    send_param_to_uart();
    return;
  }

  if (pnum == PNUM_DCF_OFFSET)
  {
    temp = value_buf2byte(0,3);
    if (temp < 48)
    {
      eeprom_data_wbv(&eeprom_data.dcf_offset,temp-24);
      invalidate_dcf_time();
    }
    send_param_to_uart();
    return;
  }

  if (pnum == PNUM_FADING_TIME)
  {
    eeprom_data_wbv(&eeprom_data.fading_time,value_buf2byte(0,3));
    send_param_to_uart();
    return;
  }
}


void process_value_char(u08 c)

{
  if ((!value_len) && ((c == '=') || (c == ' ')))
    return;
  if ((c == 0x0D) || (c == 0x0A))
  {
    receive_mode = rm_normal;
    set_value_from_uart();
    return;
  }
  value_buf[value_len] = c;
  value_len++;
  if (value_len == MAX_VALUE_LEN)
  {
    receive_mode = rm_normal;
    set_value_from_uart();
    return;
  }
}


SIGNAL(SIG_UART_RECV)

{ u08 temp;

  temp = inp(UDR);
  sei();

  switch (receive_mode)
  {
    case rm_normal :
      switch (temp)
      {
        case 'C' :
          invalidate_dcf_time();
          break;
        case 'R' :
          receive_mode = rm_rreceived;
          break;
        case 'W' :
          receive_mode = rm_wreceived;
          break;
      }
      break;
    case rm_rreceived :
    case rm_wreceived :
      if ((temp >= '0') && (temp <= '9'))
      {
      	receive_mode++; // = rm_r1received;
      	pnum_buf[0] = temp;
      }
      else
        receive_mode = rm_normal;
      break;

    case rm_r1received :
      if ((temp >= '0') && (temp <= '9'))
      {
      	pnum_buf[1] = temp;
      	pbuf2pnum();
      	if (pnum != 0xFF)
      	  send_param_to_uart();
      }
      receive_mode = rm_normal;
      break;

    case rm_w1received :
      if ((temp >= '0') && (temp <= '9'))
      {
      	pnum_buf[1] = temp;
      	pbuf2pnum();
      	if (pnum != 0xFF)
      	{
      	  receive_mode = rm_receivingdata;
      	  value_len = 0;
      	}
        else
          receive_mode = rm_normal;
      }
      else
        receive_mode = rm_normal;
      break;
    case rm_receivingdata :
      process_value_char(temp);
      break;
  }
}
/*
SIGNAL(SIG_UART_RECV)

{ u08 temp;


  temp = inp(UDR);
  char_to_uart_ibuf(temp);
}
*/
